import 'reflect-metadata';
import { BaseClass } from './interfaces/BaseClass';
export declare const Service: () => (target: BaseClass) => void;
export declare const Injectable: () => (target: BaseClass) => void;
export declare const Middleware: (...middleware: BaseClass[]) => MethodDecorator;
export declare const Controller: (prefix?: string) => (target: BaseClass) => void;
export declare const Get: (path: string) => MethodDecorator;
export declare const Post: (path: string) => MethodDecorator;
export declare const Put: (path: string) => MethodDecorator;
export declare const Patch: (path: string) => MethodDecorator;
export declare const Delete: (path: string) => MethodDecorator;
export declare const Options: (path: string) => MethodDecorator;
export declare const Req: (target: any, property: string, index: number) => void;
export declare const Res: (target: any, property: string, index: number) => void;
export declare const Param: (param?: string | undefined) => ParameterDecorator;
export declare const Body: (param?: string | undefined) => ParameterDecorator;
export declare const Query: (param?: string | undefined) => ParameterDecorator;
export declare const Header: (param?: string | undefined) => ParameterDecorator;
